#include <Windows.h>
#include <Windowsx.h>
#include "resource.h"

#pragma comment(lib, "User32.lib")


int power;
int defaultButton;

// sprintf with %g and double makes code WAY bigger
LPSTR format_ticks(DWORD ticks, LPSTR bufend)
{
	int dec;

	*bufend-- = '\0';
	*bufend-- = 's';

	for (dec = 3; dec > 1 && !(ticks % 10); dec--, ticks /= 10);

	while (dec)
	{
		*bufend-- = '0' + (ticks % 10);
		ticks /= 10;
		dec--;
	}

	*bufend = '.';

	do
	{
		*--bufend = '0' + (ticks % 10);
		ticks /= 10;
	} while (ticks);

	return bufend;
}

DWORD WINAPI CreateBench(HWND dlg)
{
	int i, num = 100;

	DWORD start;
	char timebuf[10];

	// pow(10, power) makes code WAY bigger
	for (i = 2; i < power; i++, num *= 10);

	i = num;


	SetDlgItemTextA(dlg, IDC_TIME_CRE, "Running...");

	start = GetTickCount();

	while (i--)
	{
		HWND dummy = CreateWindowA("Static", "Dummy test", WS_CHILD, 0, 0, 128, 64, dlg, NULL, NULL, NULL);
		DestroyWindow(dummy);
	}

	SetDlgItemTextA(dlg, IDC_TIME_CRE, format_ticks(GetTickCount() - start, &timebuf[9]));

	EnableWindow(GetDlgItem(dlg, IDC_RUN_CRE), TRUE);

	return 0;
}

DWORD WINAPI AccessBench(HWND dlg)
{
	int i, num = 10000;

	int item = IDC_TIME_ACC_1;
	HWND testWin = 0;
	DWORD start;
	char timebuf[10];

	// pow(10, power) makes code WAY bigger
	for (i = 4; i < power; i++, num *= 10);

	i = num;

begin:
	SetDlgItemTextA(dlg, item, "Running...");

	start = GetTickCount();

	while (i--)
	{
		IsWindowVisible(testWin);
	}

	SetDlgItemTextA(dlg, item, format_ticks(GetTickCount() - start, &timebuf[9]));

	if (!testWin)
	{
		i = num * 100;
		item = IDC_TIME_ACC_2;
		testWin = dlg;

		goto begin;
	}

	EnableWindow(GetDlgItem(dlg, IDC_RUN_ACC), TRUE);

	return 0;
}

INT_PTR CALLBACK DlgProc(HWND hwnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	switch (Msg)
	{
		case WM_INITDIALOG:
			SendMessage(hwnd, WM_SETICON, ICON_SMALL, (LPARAM) LoadIcon(NULL, IDI_APPLICATION));

			Edit_LimitText(GetDlgItem(hwnd, IDC_POW_CRE), 1);
			Edit_LimitText(GetDlgItem(hwnd, IDC_POW_ACC), 1);

			SetDlgItemInt(hwnd, IDC_POW_CRE, 3, FALSE);
			SetDlgItemInt(hwnd, IDC_POW_ACC, 5, FALSE);
			break;
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
				case IDC_RUN_CRE:
					power = GetDlgItemInt(hwnd, IDC_POW_CRE, NULL, FALSE);

					if (power >= 2 && power <= 6)
					{
						EnableWindow(GetDlgItem(hwnd, IDC_RUN_CRE), FALSE);
						CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) CreateBench, (LPVOID) hwnd, 0, NULL);
					}
					else
					{
						MessageBoxA(hwnd, "Power should be between 2 and 6! :-)", "Error", MB_OK | MB_ICONWARNING);
					}

					break;
				case IDC_RUN_ACC:
					power = GetDlgItemInt(hwnd, IDC_POW_ACC, NULL, FALSE);

					if (power >= 4 && power <= 7)
					{
						EnableWindow(GetDlgItem(hwnd, IDC_RUN_ACC), FALSE);
						CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE) AccessBench, (LPVOID) hwnd, 0, NULL);
					}
					else
					{
						MessageBoxA(hwnd, "Power should be between 4 and 7! :-)", "Error", MB_OK | MB_ICONWARNING);
					}

					break;
				case IDOK: // ENTER pressed in field
					//SendMessage(hwnd, WM_COMMAND, MAKEWPARAM(defaultButton, 0), 0);
					//SendDlgItemMessage(hwnd, defaultButton, BM_CLICK, 0, 0);
					break;
				case IDCANCEL:
					EndDialog(hwnd, IDCANCEL);
					break;
				case IDC_POW_CRE:
				case IDC_POW_ACC:
					if (HIWORD(wParam) == EN_SETFOCUS)
					{
						SendMessage(hwnd, DM_SETDEFID, LOWORD(wParam) == IDC_POW_CRE ? IDC_RUN_CRE : IDC_RUN_ACC, 0);
						//defaultButton = LOWORD(wParam) == IDC_POW_CRE ? IDC_RUN_CRE : IDC_RUN_ACC;
						break;
					}
			}
		default:
			return FALSE;
	}

	return TRUE;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, DlgProc);

	return 0;
}
